// DHHalLib_Test_App.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "DHHalLib_Test_App.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;
	BacklightTest backlightTest;
	ControlTest controlTest;
	GPIOTest gpioTest;
	I2CTest i2cTest;
	MEMTest memTest;
	TouchTest touchTest;
	VersionTest versionTest;
	SPITest spiTest;


	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		int TEST_SELECT;

		// Wait Loop for 0 to Exit
		do
		{
			cout << "---------------------------------" << endl;
			cout << "DHHalLib Test Selection!" << endl;
			cout << "---------------------------------" << endl;
			cout << "1: Backlight Function Test" << endl;
			cout << "2: Control Function Test" << endl;
			cout << "3: Gpio Function Test" << endl;
			cout << "4: I2c Function Test" << endl;
			cout << "5: Physical Memory Function Test" << endl;
			cout << "6: Touch Function Test" << endl;
			cout << "7: Version Function Test" << endl;
			cout << "8: SPI Function Test" << endl;
			cout << "0: Exit App" << endl;
			cout << "---------------------------------" << endl;
			cout << "Enter Test Number: (0 ... 7): ";
			cin >> TEST_SELECT;

			switch(TEST_SELECT)
			{
			case 1:
				{
					backlightTest.StartBacklightTest();
				}
				break;
			case 2:
				{
					controlTest.StartControlTest();
				}
				break;
			case 3:
				{
					gpioTest.StartGpioTest();
				}
				break;
			case 4:
				{
					i2cTest.StartI2cTest();
				}
				break;
			case 5:
				{
					memTest.StartMemTest();
				}
				break;
			case 6:
				{
					touchTest.StartTouchTest();
				}
				break;
			case 7:
				{
					versionTest.StartVersionTest();
				}
				break;
			case 8:
				{
					spiTest.StartSpiTest();
				}
				break;
			case 0:
				{
					return true;
				}
			default:
				{
					cout << "Not valid Test Function!!!" << endl;
				}
				break;
			}
		}while(1); //GPIO_PIN_TEST != 0);
	}

	return nRetCode;
}
