/*
//	Description: Demo Physical Memory Functions
//	File:		MEMTest.cpp
//	Created:	Christian Apfel
//	Date:		15.12.2015
//
*/

#include "stdafx.h"
#include "MEMTest.h"

using namespace std;

MEMTest::MEMTest()
{

}

MEMTest::~MEMTest()
{

}

// ****** Demo App Menu Functions ******

void MEMTest::StartMemTest()
{
	int MEM_TEST;
	int MEM_REG_ADDRESS;
	int MEM_REG_VALUE;
	int MEM_RET_VALUE;
	//unsigned char MEM_REG_ADDRESS[8];
	/*unsigned char MEM_REG_VALUE_ARRAY[8];
	unsigned char MEM_RET_VALUE_ARRAY[8];*/
	char *cStatus = new char[20];

	// Wait Loop for 0 to Exit
	do
	{
		cout << "---------------------------------" << endl;
		cout << "Select Gpio Test!" << endl;
		cout << "---------------------------------" << endl;
		cout << "1: Write Register Test" << endl;
		cout << "2: Read Register Test" << endl;
		cout << "3: Write and Return Register Test" << endl;
		cout << "0: Main Menu" << endl;
		cout << "---------------------------------" << endl;
		cout << "Enter Test Number: ";
		cin >> MEM_TEST;

		switch(MEM_TEST)
		{
		case 1:
			{
				cout << endl;
				cout << "Write Register Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Register Address (e.g. 209c700 = 0x0209c700): ";
				cin >> std::hex >> MEM_REG_ADDRESS;
				//scanf("%x", MEM_REG_ADDRESS);
				cout << "Enter Register Value Pin (e.g. 1 = 0x1): ";
				cin >> std::hex >> MEM_REG_VALUE;
				//scanf("%x", MEM_REG_VALUE);

				if(WriteRegisterTest(MEM_REG_ADDRESS, MEM_REG_VALUE) == true)
				{
					strcpy(cStatus, "Success");
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				cout << "Memory Write Test Register: " << MEM_REG_ADDRESS << " | Value: " << std::hex << MEM_REG_VALUE << " | " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 2:
			{
				cout << endl;
				cout << "Read Register Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Register Address (e.g. 209c700 = 0x0209c700)";
				cin >> std::hex >> MEM_REG_ADDRESS;
				//scanf("%x", MEM_REG_ADDRESS);

				if(ReadRegisterTest(MEM_REG_ADDRESS, &MEM_RET_VALUE) == true)
				{
					strcpy(cStatus, "Success");
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				cout << "Memory Read Test Register: " << std::hex << MEM_REG_ADDRESS << " | Value: " << std::hex << MEM_RET_VALUE << " | " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 3:
			{
				cout << endl;
				cout << "Write and Return Register Test" << endl;
				cout << "------------------------------------" << endl;
				cout << "Enter Register Address (e.g. 209c700 = 0x0209c700): ";
				cin >> std::hex >> MEM_REG_ADDRESS;
				//scanf("%x", MEM_REG_ADDRESS);
				cout << "Enter Register Value Pin (e.g. 0x01): ";
				cin >> std::hex >> MEM_REG_VALUE;
				//scanf("%x", MEM_REG_VALUE);

				if(WriteBackRegisterTest(MEM_REG_ADDRESS, MEM_REG_VALUE, &MEM_RET_VALUE) == true)
				{
					if(MEM_REG_VALUE == MEM_RET_VALUE)
					{
						strcpy(cStatus, "Success");
					}
					else
					{
						strcpy(cStatus, "Failed");
					}
				}
				else
				{
					strcpy(cStatus, "Failed");
				}

				cout << "Memory Write Test Register: " << MEM_REG_ADDRESS << " | Value: " << std::hex << MEM_REG_VALUE << " | Return " << std::hex << MEM_RET_VALUE << " | " << cStatus << "!!!" << endl;
				cout << "------------------------------------" << endl;
			}
			break;
		case 0:
			{
				delete(cStatus);
				return;
			}
		default:
			{
				cout << "Not valid Test Function!!!" << endl;
			}
			break;
		}
	}while(1);
}

// ****** Physical Memory Functions ******

bool MEMTest::WriteRegisterTest(int iPhyAddr, int iRegValue)
{
	//unsigned long ulReturn = (ULONG)WritePhysicalAddress((UINT32)0x0209c000, 32, 0x00000000, true);
	
	if(!WritePhysicalAddress(iPhyAddr, 32, iRegValue, false))
	{
		cout << "Physical Write successful" << endl;
		return true;
	}

	return false;
}

bool MEMTest::ReadRegisterTest(int iPhyAddr, int *iRegBackValue)
{
	/*int iReturn = ReadPhysicalAddress(0x0209c720, 32);

	cout << "Return of Register: 0x0209c720 Value: " << iReturn << endl;*/

	//cout << "Address Value: " << std::hex << iPhyAddr << endl;

	//cout << "Address Value: " << std::hex << "0x0209c700" << endl;

	*iRegBackValue = ReadPhysicalAddress(iPhyAddr, 32);

	cout << "Physical Read Return: " << *iRegBackValue << endl;

	return true;
}

bool MEMTest::WriteBackRegisterTest(int iPhyAddr, int iRegValue, int *iRegBackValue)
{
	//unsigned long lRegAddr = (ULONG)((*cPhyBaseAddr << 11) & *cPhyOffsetAddr & (*cPhyAddr >> 7));

	if((*iRegBackValue = (unsigned char)WritePhysicalAddress(iPhyAddr, 32, iRegValue, true)) == iRegValue)
	{
		return true;
	}

	return false;
}
